#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#define SMALLVAL 0.000001


int error_too_large(POINT *point){
  char string[1024];
  int result;

  if(Trace){
     our_printf("entering error_too_large()\n");
     ++Trace_level;
  } 

  if(Trace){
    sprintf(string,"point %p\ttimeslice %i\n",point,point->timeslice);
    our_printf(string);
  }

  if(point->timeslice==0){
    printf("value = %f\terror = %lf\tpoints = %i\n",point->value,point->error, point->important_point.elements);
  }

  switch(Simulation_type){
  case(0):
    /* Columbia emulation version */
    if(point->timeslice == 0){
      if(point->important_point.elements == Columbia_paths) {
        result = 0;
      }else {
        result = 1;
      } 
    }else if(point->children == 1) { 
      result = 0; 
    } else {
      result = 1; 
    }

    break;
  default:
    /* Tree and NPAC */
    if(point->important_point.elements < Minimum_points && point->timeslice != 0){
      result = 1;
    }else if(point->important_point.elements < Slice_two_points && point->timeslice == 0){
      result = 1;
    }else if(point->value == 0.0 && point->error == 0.0 ){
       result = 0;
    }else if(point->value == 0.0 ){
       if (point->error < SMALLVAL ) {
         result = 0;
       }else {
         result = 1;
       }
    }else if(point->error/point->value < Error_floor){
      result = 0;
    }else if(point->error/point->value > Error_ceiling){
      result = 1;
    }else if(point->error > Error_target*fabs(point->delta_r)){
      result = 1;
    }else{
      result = 0;
    }
    break;
  }
  
   if(Trace){ 
     --Trace_level; 
     our_printf("exiting error_too_large()\n"); 
   } 

  return(result);
}
        
        
        
