#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "ranlib.h"
#include "our_getopt.h"
#include "plist.h"
#include "blackScholes.h"

void columbia(void);
void post_columbia(void);

int main(int argc, char *argv[]){
  int i,j, count, timeslice;
  POINT initial_point ;

  handle_command_line(argc,argv);

  if(Trace){
    Trace_file_handle = fopen(Trace_file,"a");
    our_printf("entered main()\n");
    ++Trace_level;
  }

  init_rng();

  allocate1dPLIST(&Time,Timeslices);

  point_initialize(&initial_point);
  for(i=0; i<Dimensions; i++) initial_point.price[i] = Initial_price;

  add_point_to_mesh(&initial_point, NULL, 0);
  value((POINT*)0,&(Time[0].element[0]));


/*   for(i=0;i<Timeslices;i++){ */
/*     printf("Timeslice = %i\n",i); */
/*     for(j=0;j<Time[i].elements;j++){ */
/*       printf("Time[%i].elemnt[%i].timeslice = %i\n",i,j,Time[i].element[j].timeslice); */
/*     } */
/*   } */

  for(timeslice = Timeslices-2; timeslice>=0 ; timeslice--){
    printf("*******> time = %d of %d\n", timeslice, Timeslices-1);
    printf("  number of elements at t+1= %d\n", Time[timeslice+1].elements);
  }

  if(Simulation_type == 0 ){
    printf("Before columbia correction: %lf +/- %lf\n",Time[0].element[0].value,Time[0].element[0].error);
    columbia();
    printf("The option value is: %lf +/- %lf\n",Time[0].element[0].value,Time[0].element[0].error);
  }else{
    printf("Option value is %lf +/- %lf\n",Time[0].element[0].value,Time[0].element[0].error);
  }
  if(Post_columbia == 1){
    post_columbia();
    printf("After post-processing Columbia \n option value is: %lf +/- %lf\n",Time[0].element[0].value,Time[0] .element[0].error);
  }

  printf("european = %lf\n", euroCall(Initial_price, Strike_price, Interest_rate, sqrt(Covariance[0][0]),
				      Timeslices-1, Dividend_rate[0]));

  if(Trace){
    --Trace_level;
    our_printf("exiting main()\n");
  }

  return(0);
}
